use Test::Simple tests => 4;
use strict;
use DE_EPAGES::Core::API::Error qw ( ExistsError );
use DE_EPAGES::Core::API::SystemCommand qw(SystemCommand ShellCommand);
use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::Core::API::File qw ( DeleteDirectory DeleteFile GetFileNames);

sub Main {
    my $BackupHost = `/var/epages/ini-config.sh -f $ENV{'EPAGES_CONFIG'}/Database.d/Store.conf -k 'BackupHost' -g`;
    $BackupHost =~ s/\s+$//g;
    my $TestHost = '127.0.0.1';

    if($BackupHost eq 'localhost') { 
        $TestHost = '127.0.0.1';
    }else {
        $TestHost = 'localhost';
    }

    
    CleanUp();
    ok ( Test_MySQLBackup() );
    ok ( Test_MySQLDumpFile() );
    ok ( Test_MySQLDumps() );
    
    ShellCommand("/var/epages/ini-config.sh -f $ENV{'EPAGES_CONFIG'}/Database.d/Store.conf -k 'BackupHost' -i -v ".$TestHost);
    ok ( Test_MySQLDumps() );

    
    ShellCommand("/var/epages/ini-config.sh -f $ENV{'EPAGES_CONFIG'}/Database.d/Store.conf -k 'BackupHost' -i -v ".$BackupHost);
    CleanUp();
}

RunScript( Sub => \&Main);

sub Test_MySQLBackup {
    eval {
        SystemCommand("$ENV{PERL} $ENV{'EPAGES_CARTRIDGES'}/DE_EPAGES/Database/Scripts/MySQLBackup.pl -full -storename Store -dumpdir '/tmp/MySQLDump'");
    };
    if(ExistsError()) {
        return 0;        
    }
    return 1;
}

sub Test_MySQLDumpFile {
    return 1 unless(scalar @{ GetFileNames('/tmp/MySQLDump') } < 1);
    return 0;
}

sub Test_MySQLDumps {
    eval {
        SystemCommand("$ENV{PERL} $ENV{'EPAGES_CARTRIDGES'}/DE_EPAGES/Database/Scripts/MySQLDumps.pl -fullbackup -target /tmp/full_backup_db -storename Store");
    };
    if(ExistsError()) {
        return 0;        
    }
    return 1;
}

sub CleanUp {
    DeleteDirectory('/tmp/MySQLDump', {'recursive' => 1});
    DeleteFile('/tmp/fullbackup');
}

1;
